> ## Documentation Index
> Fetch the complete documentation index at: https://developer.upsun.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get list of project settings

> Retrieve the global settings for a project.



## OpenAPI

````yaml https://meta.upsun.com/openapi-spec get /projects/{projectId}/settings
openapi: 3.0.1
info:
  title: Upsun.com Rest API
  version: '1.0'
  contact:
    name: Support
    url: https://upsun.com/contact-us/
  termsOfService: https://upsun.com/trust-center/legal/tos/
  description: >
    # Introduction


    Upsun, formerly Platform.sh, is a container-based Platform-as-a-Service. Our
    main API

    is simply Git. With a single `git push` and a couple of YAML files in

    your repository you can deploy an arbitrarily complex cluster.

    Every [**Project**](#tag/Project) can have multiple applications (PHP,

    Node.js, Python, Ruby, Go, etc.) and managed, automatically

    provisioned services (databases, message queues, etc.).


    Each project also comes with multiple concurrent

    live staging/development [**Environments**](#tag/Environment).

    These ephemeral development environments

    are automatically created every time you push a new branch or create a

    pull request, and each has a full copy of the data of its parent branch,

    which is created on-the-fly in seconds.


    Our Git implementation supports integrations with third party Git

    providers such as GitHub, Bitbucket, or GitLab, allowing you to simply

    integrate Upsun into your existing workflow.


    ## Using the REST API


    In addition to the Git API, we also offer a REST API that allows you to
    manage

    every aspect of the platform, from managing projects and environments,

    to accessing accounts and subscriptions, to creating robust workflows

    and integrations with your CI systems and internal services.


    These API docs are generated from a standard **OpenAPI (Swagger)**
    Specification document

    which you can find here in [YAML](openapispec-upsun.yaml) and in
    [JSON](openapispec-upsun.json) formats.


    This RESTful API consumes and produces HAL-style JSON over HTTPS,

    and any REST library can be used to access it. On GitHub, we also host

    a few API libraries that you can use to make API access easier, such as our

    [PHP API client](https://github.com/upsun/upsun-sdk-php).


    In order to use the API you will first need to have an [Upsun
    account](https://auth.upsun.com/register/) 

    and [create an API Token](https://docs.upsun.com/anchors/cli/api-token/).


    # Authentication


    ## OAuth2


    API authentication is done with OAuth2 access tokens.


    ### API tokens


    You can use an API token as one way to get an OAuth2 access token. This

    is particularly useful in scripts, e.g. for CI pipelines.


    To create an API token, go to the "API Tokens" section

    of the "Account Settings" tab on the [Console](https://console.upsun.com).


    To exchange this API token for an access token, a `POST` request

    must be made to `https://auth.upsun.com/oauth2/token`.


    The request will look like this in cURL:


    <pre>

    curl -u platform-api-user: \
        -d 'grant_type=api_token&amp;api_token=<em><b>API_TOKEN</b></em>' \
        https://auth.upsun.com/oauth2/token
    </pre>


    This will return a "Bearer" access token that

    can be used to authenticate further API requests, for example:


    <pre>

    {
        "access_token": "<em><b>abcdefghij1234567890</b></em>",
        "expires_in": 900,
        "token_type": "bearer"
    }

    </pre>


    ### Using the Access Token


    To authenticate further API requests, include this returned bearer token

    in the `Authorization` header. For example, to retrieve a list of

    [Projects](#tag/Project)

    accessible by the current user, you can make the following request

    (substituting the dummy token for your own):


    <pre>

    curl -H "Authorization: Bearer <em><b>abcdefghij1234567890</b></em>" \
        https://api.upsun.com/projects
    </pre>


    # HAL Links


    Most endpoints in the API return fields which defines a HAL

    (Hypertext Application Language) schema for the requested endpoint.

    The particular objects returns and their contents can vary by endpoint.

    The payload examples we give here for the requests do not show these

    elements. These links can allow you to create a fully dynamic API client

    that does not need to hardcode any method or schema.


    Unless they are used for pagination we do not show the HAL links in the

    payload examples in this documentation for brevity and as their content

    is contextual (based on the permissions of the user).


    ## _links Objects


    Most endpoints that respond to `GET` requests will include a `_links` object

    in their response. The `_links` object contains a key-object pair labelled
    `self`, which defines

    two further key-value pairs:


    * `href` - A URL string referring to the fully qualified name of the
    returned object. For many endpoints, this will be the direct link to the API
    endpoint on the region gateway, rather than on the general API gateway. This
    means it may reference a host of, for example, `eu-2.platform.sh` rather
    than `api.upsun.com`.

    * `meta` - An object defining the OpenAPI Specification (OAS) [schema
    object](https://swagger.io/specification/#schemaObject) of the component
    returned by the endpoint.


    There may be zero or more other fields in the `_links` object resembling
    fragment identifiers

    beginning with a hash mark, e.g. `#edit` or `#delete`. Each of these keys

    refers to a JSON object containing two key-value pairs:


    * `href` - A URL string referring to the path name of endpoint which can
    perform the action named in the key.

    * `meta` - An object defining the OAS schema of the endpoint. This consists
    of a key-value pair, with the key defining an HTTP method and the value
    defining the [operation
    object](https://swagger.io/specification/#operationObject) of the endpoint.


    To use one of these HAL links, you must send a new request to the URL
    defined

    in the `href` field which contains a body defined the schema object in the
    `meta` field.


    For example, if you make a request such as `GET
    /projects/abcdefghij1234567890`, the `_links`

    object in the returned response will include the key `#delete`. That object

    will look something like this fragment:


    ```

    "#delete": {
        "href": "/api/projects/abcdefghij1234567890",
        "meta": {
            "delete": {
                "responses": {
                    . . . // Response definition omitted for space
                },
                "parameters": []
            }
        }
    }

    ```


    To use this information to delete a project, you would then send a `DELETE`

    request to the endpoint
    `https://api.upsun.com/api/projects/abcdefghij1234567890`

    with no body or parameters to delete the project that was originally
    requested.


    ## _embedded Objects


    Requests to endpoints which create or modify objects, such as `POST`,
    `PATCH`, or `DELETE`

    requests, will include an `_embedded` key in their response. The object

    represented by this key will contain the created or modified object. This

    object is identical to what would be returned by a subsequent `GET` request

    for the object referred to by the endpoint.
  x-logo:
    url: https://docs.upsun.com/images/upsun-api.svg
    href: https://upsun.com/#section/Introduction
    altText: Upsun logo
servers:
  - url: '{schemes}://api.upsun.com'
    description: The Upsun.com API gateway
    variables:
      schemes:
        default: https
security:
  - BearerAuth: []
tags:
  - name: Cert Management
    description: >
      User-supplied SSL/TLS certificates can be managed using these

      endpoints. You can now list and modify certificate provisioners

      using the `/projects/{projectId}/provisioners` and

      `/projects/{projectId}/provisioners/{certificateProvisionerDocumentId}`

      endpoints. For more information, see our

      [Third-party TLS
      certificate](https://docs.upsun.com/anchors/domains/custom/custom-certificates/)

      documentation. These endpoints are not for managing certificates

      that are automatically supplied by Upsun via Let's Encrypt.
  - name: Environment
    description: |
      On Upsun, an environment encompasses a single instance of your
      entire application stack, the services used by the application,
      the application's data storage, and the environment's backups.

      In general, an environment represents a single branch or merge request
      in the Git repository backing a project. It is a virtual cluster
      of read-only application and service containers with read-write
      mounts for application and service data.

      On Upsun, the default branch is your production environment—thus,
      merging changes to this branch will put those changes to production.
  - name: Environment Type
    description: >
      Environment Types is the way Upsun manages access. We currently have 3
      environment types:

      * Development

      * Staging

      * Production


      Each environment type will contain a group of users and their accesses. We
      manage access,

      adding, updating and removing users and their roles, here.


      Each environment will have a type, pointing to one of these 3 environment
      types.

      See `type` in [Environments](#tag/Environment).


      In general:

      * Production will be reserved for the default branch, and cannot be set
      manually.

      * An environment can be set to be type `staging` or development manually
      and when branching.


      Dedicated Generation 2 projects have different rules for environment
      types. If your project

      contains at least one of those Dedicated Generation 2 environments, the
      rules are slightly different:

      * All non-dedicated environments in your project can be `development` or
      `staging`, but never `production`.

      * Dedicated Generation 2 environments can be set either to `staging` or
      `production`, but never `development`.

      * The default branch is not considered to be a special case.
  - name: Environment Backups
    description: |
      A snapshot is a complete backup of an environment, including all the
      persistent data from all services running in an environment and all
      files present in mounted volumes.

      These endpoints can be used to trigger the creation of new backups,
      get information about existing backups, delete existing backups or
      restore a backup.
      More information about backups can be found in our
      [documentation](https://docs.upsun.com/anchors/environments/backup/).
  - name: Environment Variables
    description: >
      These endpoints manipulate user-defined variables which are bound to a

      specific environment, as well as (optionally) the children of an

      environment. These variables can be made available at both build time

      and runtime. For more information on environment variables,

      see the
      [Variables](https://docs.upsun.com/anchors/variables/set/environment/create/)

      section of the documentation.
  - name: Autoscaling
    description: >
      Upsun provides native support for autoscaling, allowing your applications
      to automatically adjust based on resource usage.

      This ensures that your apps remain responsive under load while helping you
      optimize costs.

      You can configure thresholds for metrics such as CPU, RAM, and request
      latency.  

      Resources will automatically scale to meet demand.

      Each container profile assigned to an application or service provides a
      specific combination of CPU and RAM, which you can select via the Upsun UI
      or CLI.


      These endpoints manage autoscaling configurations that are tied to a

      specific environment, and optionally to its child environments.

      You can define scaling rules based on metrics like CPU, memory, or

      request latency, and these rules will be applied at both build time

      and runtime. For more information on configuring autoscaling for your

      environments, see the
      [Autoscaling](https://docs.upsun.com/manage-resources/autoscaling.html)
      section

      of the documentation.
  - name: Project
    description: >
      ## Project Overview


      On Upsun, a Project is backed by a single Git repository

      and encompasses your entire application stack, the services

      used by your application, the application's data storage,

      the production and staging environments, and the backups of those

      environments.


      When you create a new project, you start with a single

      [Environment](#tag/Environment) called *Master*,

      corresponding to the master branch in the Git repository of

      the project—this will be your production environment.


      If you connect your project to an external Git repo

      using one of our [Third-Party Integrations](#tag/Third-Party-Integrations)

      a new development environment can be created for each branch

      or pull request created in the repository. When a new development

      environment is created, the production environment's data

      will be cloned on-the-fly, giving you an isolated, production-ready

      test environment.


      This set of API endpoints can be used to retrieve a list of projects

      associated with an API key, as well as create and update the parameters

      of existing projects.


      > **Note**:

      >

      > To list projects or to create a new project, use
      [`/subscriptions`](#tag/Subscriptions).
  - name: Project Variables
    description: >
      These endpoints manipulate user-defined variables which are bound to an

      entire project. These variables are accessible to all environments

      within a single project, and they can be made available at both build

      time and runtime. For more information on project variables,

      see the
      [Variables](https://docs.upsun.com/anchors/variables/set/project/create/)

      section of the documentation.
  - name: Project Settings
    description: >
      These endpoints can be used to retrieve and manipulate project-level

      settings. Only the `initialize` property can be set by end users. It is
      used

      to initialize a project from an existing Git repository.


      The other properties can only be set by a privileged user.
  - name: Repository
    description: >
      The Git repository backing projects hosted on Upsun can be

      accessed in a **read-only** manner through the
      `/projects/{projectId}/git/*`

      family of endpoints. With these endpoints, you can retrieve objects from

      the Git repository in the same way that you would in a local environment.
  - name: Domain Management
    description: |
      These endpoints can be used to add, modify, or remove domains from
      a project. For more information on how domains function on
      Upsun, see the [Domains](https://docs.upsun.com/anchors/domains/custom/)
      section of our documentation.
  - name: Routing
    description: >
      These endpoints modify an environment's `routes:` section of the
      `.upsun/config.yaml` file.

      For routes to propagate to child environments, the child environments

      must be synchronized with their parent.


      More information about routing can be found in the
      [Routes](https://docs.upsun.com/anchors/routes/)

      section of the documentation.
  - name: Source Operations
    description: >
      These endpoints interact with source code operations as defined in the
      `source.operations`

      key in a project's `.upsun/config.yaml` configuration. More information

      on source code operations is

      [available in our user
      documentation](https://docs.upsun.com/anchors/app/source-operations/).
  - name: Deployment Target
    description: |
      Upsun is capable of deploying the production environments of
      projects in multiple topologies: both in clusters of containers, and
      as dedicated virtual machines. This is an internal API that can
      only be used by privileged users.
  - name: Deployments
    description: |
      The deployments endpoints gives detailed information about the actual
      deployment of an active environment. Currently, it returns the _current_
      deployment with information about the different apps, services, and
      routes contained within.
  - name: Third-Party Integrations
    description: |
      Upsun can easily integrate with many third-party services, including
      Git hosting services (GitHub, GitLab, and Bitbucket),
      health notification services (email, Slack, PagerDuty),
      performance analytics platforms (New Relic, Blackfire, Tideways),
      and webhooks.

      For clarification about what information each field requires, see the
      [External Integrations](https://docs.upsun.com/anchors/integrations/)
      documentation. NOTE: The names of the CLI arguments listed in the
      documentation are not always named exactly the same as the
      required body fields in the API request.
  - name: MFA
    description: >
      Multi-factor authentication (MFA) requires the user to present two (or
      more) types of evidence (or factors) to prove their identity.


      For example, the evidence might be a password and a device-generated code,
      which show the user has the knowledge factor ("something you know") 

      as well as the possession factor ("something you have"). In this way MFA
      offers good protection against the compromise of any single factor, 

      such as a stolen password.


      Using the MFA API you can set up time-based one-time passcodes (TOTP),
      which can be generated on a single registered device ("something you
      have") such as a mobile phone.
  - name: Subscriptions
    description: >
      Each project is represented by a subscription that holds the plan
      information.

      These endpoints can be used to go to a larger plan, add more storage, or
      subscribe to

      optional features.
  - name: Orders
    description: |
      These endpoints can be used to retrieve order information from our billing
      system. Here you can view information about your bill for our services,
      include the billed amount and a link to a PDF of the bill.
  - name: Invoices
    description: >
      These endpoints can be used to retrieve invoices from our billing system.

      An invoice of type "invoice" is generated automatically every month, if
      the customer has active projects.

      Invoices of type "credit_memo" are a result of manual action when there
      was a refund or an invoice correction.
  - name: Vouchers
    description: >
      These endpoints can be used to retrieve vouchers associated with a
      particular

      user as well as apply a voucher to a particular user.
  - name: Records
    description: >
      These endpoints retrieve information about which plans were assigned to a
      particular

      project at which time.
  - name: Support
    description: >
      These endpoints can be used to retrieve information about support ticket
      priority

      and allow you to submit new ticket to the Upsun Support Team.
  - name: System Information
    description: >
      These endpoints can be used to retrieve low-level information and interact
      with the

      core component of Upsun infrastructure.


      This is an internal API that can only be used by privileged users.
paths:
  /projects/{projectId}/settings:
    get:
      tags:
        - Project Settings
      summary: Get list of project settings
      description: Retrieve the global settings for a project.
      operationId: get-projects-settings
      parameters:
        - in: path
          required: true
          schema:
            type: string
          name: projectId
      responses:
        default:
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectSettings'
components:
  schemas:
    ProjectSettings:
      type: object
      properties:
        initialize:
          type: object
          title: Initialization key
          description: ''
        product_name:
          type: string
          title: Product Name
          description: The name of the product.
        product_code:
          type: string
          title: Product Code
          description: The lowercase ASCII code of the product.
        ui_uri_template:
          type: string
          title: UI URI Template
          description: The template of the project UI uri
        variables_prefix:
          type: string
          title: Variables Prefix
          description: The prefix of the generated environment variables.
        bot_email:
          type: string
          title: Bot Email
          description: The email of the bot.
        application_config_file:
          type: string
          title: Application Config File
          description: The name of the application-specific configuration file.
        project_config_dir:
          type: string
          title: Project Config Directory
          description: The name of the project configuration directory.
        use_drupal_defaults:
          type: boolean
          title: Use Drupal Defaults
          description: >-
            Whether to use the default Drupal-centric configuration files when
            missing from the repository.
        use_legacy_subdomains:
          type: boolean
          title: Use Legacy Subdomains
          description: >-
            Whether to use legacy subdomain scheme, that replaces `.` by `---`
            in development subdomains.
        development_service_size:
          type: string
          enum:
            - 2XL
            - 4XL
            - L
            - M
            - S
            - XL
          title: Development Service Size
          description: The size of development services.
        development_application_size:
          type: string
          enum:
            - 2XL
            - 4XL
            - L
            - M
            - S
            - XL
          title: Development Application Size
          description: The size of development applications.
        enable_certificate_provisioning:
          type: boolean
          title: Enable Certificate Provisioning
          description: Enable automatic certificate provisioning.
        certificate_style:
          type: string
          enum:
            - ecdsa
            - rsa
          title: Certificate Style
          description: ''
        certificate_renewal_activity:
          type: boolean
          title: Certificate Renewal Activity
          description: Create an activity for certificate renewal
        development_domain_template:
          type: string
          nullable: true
          title: Development Domain Template
          description: >-
            The template of the development domain, can include {project} and
            {environment} placeholders.
        enable_state_api_deployments:
          type: boolean
          title: Enable State API Deployments
          description: >-
            Enable the State API-driven deployments on regions that support
            them.
        temporary_disk_size:
          type: integer
          nullable: true
          title: Temporary Disk Size
          description: Set the size of the temporary disk (/tmp, in MB).
        local_disk_size:
          type: integer
          nullable: true
          title: Local Disk Size
          description: Set the size of the instance disk (in MB).
        cron_minimum_interval:
          type: integer
          title: Minimum cron interval
          description: Minimum interval between cron runs (in minutes)
        cron_maximum_jitter:
          type: integer
          title: Maximum cron jitter
          description: Maximum jitter inserted in cron runs (in minutes)
        cron_production_expiry_interval:
          type: integer
          title: Cron Production Expiry Interval
          description: >-
            The interval (in days) for which cron activity and logs are kept
            around
        cron_non_production_expiry_interval:
          type: integer
          title: Cron Non-Production Expiry Interval
          description: >-
            The interval (in days) for which cron activity and logs are kept
            around
        concurrency_limits:
          type: object
          additionalProperties:
            type: integer
            nullable: true
          title: Concurrency Limits
          description: The concurrency limits applied to different kind of activities
        flexible_build_cache:
          type: boolean
          title: Enable Flexible Build Cache
          description: Enable the flexible build cache implementation
        strict_configuration:
          type: boolean
          title: Enable Strict Configuration
          description: Strict configuration validation.
        has_sleepy_crons:
          type: boolean
          title: Enable sleepy crons.
          description: ''
        crons_in_git:
          type: boolean
          title: Enable crons from git.
          description: ''
        custom_error_template:
          type: string
          nullable: true
          title: Custom error template
          description: Custom error template for the router.
        app_error_page_template:
          type: string
          nullable: true
          title: Application error template
          description: Custom error template for the application.
        environment_name_strategy:
          type: string
          enum:
            - hash
            - name-and-hash
          title: Environment Name Strategy
          description: The strategy used to generate environment machine names
        data_retention:
          type: object
          additionalProperties:
            type: object
            properties:
              max_backups:
                type: integer
                title: Maximum Backups
                description: The maximum number of backups per environment
              default_config:
                type: object
                properties:
                  manual_count:
                    type: integer
                    title: Manual Count
                    description: The number of manual backups to keep.
                  schedule:
                    type: array
                    items:
                      type: object
                      properties:
                        interval:
                          type: string
                          title: Interval
                          description: The policy interval specification.
                        count:
                          type: integer
                          title: Count
                          description: The number of backups to keep under this interval.
                      required:
                        - interval
                        - count
                      additionalProperties: false
                    title: Schedule
                    description: The backup schedule specification.
                required:
                  - manual_count
                  - schedule
                additionalProperties: false
                title: Default Config
                description: ''
                x-stability: EXPERIMENTAL
            required:
              - max_backups
              - default_config
            additionalProperties: false
          nullable: true
          title: Data retention configuration
          description: Data retention configuration
        enable_codesource_integration_push:
          type: boolean
          title: Enable pushing commits
          description: Enable pushing commits to codesource integration.
        enforce_mfa:
          type: boolean
          title: Enforce multi-factor authentication.
          description: Enforce multi-factor authentication.
        systemd:
          type: boolean
          title: Use systemd
          description: Use systemd images.
        router_gen2:
          type: boolean
          title: Router v2
          description: Use the router v2 image.
        build_resources:
          type: object
          properties:
            cpu:
              type: number
              format: float
              title: CPU
              description: ''
            memory:
              type: integer
              title: Memory
              description: ''
          required:
            - cpu
            - memory
          additionalProperties: false
          title: Build Resources
          description: ''
        outbound_restrictions_default_policy:
          type: string
          enum:
            - allow
            - deny
          title: Outbound Restrictions Default Policy
          description: The default policy for firewall outbound restrictions
        self_upgrade:
          type: boolean
          title: Self Upgrade
          description: Whether self-upgrades are enabled
        self_upgrade_latest_major:
          type: boolean
          title: >-
            Whether to check for n+1 major version when self-upgrades are
            enabled
          description: ''
        additional_hosts:
          type: object
          additionalProperties:
            type: string
          title: Additional Hosts
          description: >-
            A mapping of hostname to ip address to be added to the container's
            hosts file
        max_allowed_routes:
          type: integer
          title: Maximum allowed routes
          description: Maximum number of routes allowed
        max_allowed_redirects_paths:
          type: integer
          title: Maximum allowed redirect paths
          description: Maximum number of redirect paths allowed
        enable_incremental_backups:
          type: boolean
          title: Enable incremental backups
          description: Enable incremental backups on regions that support them.
        sizing_api_enabled:
          type: boolean
          title: Enable sizing api
          description: Enable sizing api.
        enable_cache_grace_period:
          type: boolean
          title: Enable cache grace period
          description: Enable cache grace period.
        enable_zero_downtime_deployments:
          type: boolean
          title: Enable zero-downtime deployments
          description: Enable zero-downtime deployments for resource-only changes.
        enable_admin_agent:
          type: boolean
          title: Enable admin agent
          description: ''
        certifier_url:
          type: string
          title: Certifier URL
          description: The certifier url
        centralized_permissions:
          type: boolean
          title: Centralized Permissions
          description: Whether centralized permissions are enabled
        glue_server_max_request_size:
          type: integer
          title: Glue Server Max Request Size
          description: Maximum size of request to glue-server (in MB)
        persistent_endpoints_ssh:
          type: boolean
          title: Persistent Endpoints SSH
          description: Enable SSH access update with persistent endpoint
        persistent_endpoints_ssl_certificates:
          type: boolean
          title: Persistent Endpoints SSL Certificates
          description: Enable SSL certificate update with persistent endpoint
        enable_disk_health_monitoring:
          type: boolean
          title: Enable disk health monitoring
          description: ''
        enable_paused_environments:
          type: boolean
          title: Enable paused environments
          description: ''
        enable_unified_configuration:
          type: boolean
          title: Enable unified configuration files
          description: ''
        enable_explicit_empty_routes:
          type: boolean
          title: Enable explicit empty routes
          description: >-
            When enabled, explicitly empty routes configuration (routes: or
            routes: {}) will result in no routes being generated instead of
            fallback routes.
        enable_routes_tracing:
          type: boolean
          title: Enable routes tracing
          description: Enable tracing support in routes
        image_deployment_validation:
          type: boolean
          title: Image Deployment Validation
          description: Enable extended deployment validation by images
        support_generic_images:
          type: boolean
          title: Support composable images
          description: ''
        enable_github_app_token_exchange:
          type: boolean
          title: Enable GitHub App token exchange
          description: Enable fetching the GitHub App token from SIA.
        continuous_profiling:
          type: object
          properties:
            supported_runtimes:
              type: array
              items:
                type: string
              title: Supported runtimes
              description: List of images supported for continuous profiling
          required:
            - supported_runtimes
          additionalProperties: false
          title: Continuous profiling configuration
          description: The continuous profiling configuration
        disable_agent_error_reporter:
          type: boolean
          title: Disable agent error reporter
          description: ''
        requires_domain_ownership:
          type: boolean
          title: Require domain ownership
          description: Require ownership proof before domains are added to environments.
        enable_guaranteed_resources:
          type: boolean
          title: Enable guaranteed resources feature
          description: Enable guaranteed resources feature
        git_server:
          type: object
          properties:
            push_size_hard_limit:
              type: integer
              title: Push Size Hard Limit
              description: Push Size Reject Limit
          required:
            - push_size_hard_limit
          additionalProperties: false
          title: Git Server configuration
          description: ''
        activity_logs_max_size:
          type: integer
          title: Activity Logs Max Size
          description: >-
            The maximum size of activity logs in bytes. This limit is applied on
            the pre-compressed log size.
        allow_manual_deployments:
          type: boolean
          title: Allow Manual Deployments
          description: If deployments can be manual, i.e. explicitly triggered by user
        allow_rolling_deployments:
          type: boolean
          title: Allow Rolling Deployments
          description: If the project can use rolling deployments
        maintenance_window:
          type: object
          properties:
            recurrence:
              type: object
              properties:
                interval:
                  type: string
                  title: Interval
                  description: Interval in weeks, either 2w or 4w
                day_of_week:
                  type: integer
                  title: Day of week
                  description: Day of week, where Monday is 0
                time:
                  type: string
                  title: Time
                  description: Exact time in HH:MM format
              required:
                - interval
                - day_of_week
                - time
              additionalProperties: false
              title: Recurrence
              description: Defines the recurring schedule for the maintenance window
          required:
            - recurrence
          additionalProperties: false
          nullable: true
          title: Maintenance window configuration
          description: Configuration for the maintenance window schedule
        allow_activity_reschedule:
          type: boolean
          title: Allow activity reschedule
          description: Allow certain types of activities to be rescheduled
        allow_burst:
          type: boolean
          title: Allow burst
          description: ''
        router_resources:
          type: object
          properties:
            baseline_cpu:
              type: number
              format: float
              title: Baseline CPU
              description: Router baseline CPU for flex plan
            baseline_memory:
              type: integer
              title: Baseline Memory
              description: Router baseline memory (MB) for flex plan
            max_cpu:
              type: number
              format: float
              title: Max CPU
              description: Router max CPU for flex plan
            max_memory:
              type: integer
              title: Max Memory
              description: Router max memory (MB) for flex plan
          required:
            - baseline_cpu
            - baseline_memory
            - max_cpu
            - max_memory
          additionalProperties: false
          title: Router Resources
          description: Router resource settings for flex plan
        allow_scaling_to_zero:
          type: boolean
          title: >-
            Allow scaling apps and workers without a relationship pointing to
            them to 0
          description: ''
        save_applications_vendors:
          type: boolean
          title: Save Applications Vendors
          description: Save vendors.json files locally after builds for SBOM generation.
        locations_script_default:
          type: boolean
          title: Set the default for script execution in web locations
          description: ''
        support_oci_images:
          type: boolean
          title: Support OCI images
          description: ''
      required:
        - initialize
        - product_name
        - product_code
        - ui_uri_template
        - variables_prefix
        - bot_email
        - application_config_file
        - project_config_dir
        - use_drupal_defaults
        - use_legacy_subdomains
        - development_service_size
        - development_application_size
        - enable_certificate_provisioning
        - certificate_style
        - certificate_renewal_activity
        - development_domain_template
        - enable_state_api_deployments
        - temporary_disk_size
        - local_disk_size
        - cron_minimum_interval
        - cron_maximum_jitter
        - cron_production_expiry_interval
        - cron_non_production_expiry_interval
        - concurrency_limits
        - flexible_build_cache
        - strict_configuration
        - has_sleepy_crons
        - crons_in_git
        - custom_error_template
        - app_error_page_template
        - environment_name_strategy
        - data_retention
        - enable_codesource_integration_push
        - enforce_mfa
        - systemd
        - router_gen2
        - build_resources
        - outbound_restrictions_default_policy
        - self_upgrade
        - self_upgrade_latest_major
        - additional_hosts
        - max_allowed_routes
        - max_allowed_redirects_paths
        - enable_incremental_backups
        - sizing_api_enabled
        - enable_cache_grace_period
        - enable_zero_downtime_deployments
        - enable_admin_agent
        - certifier_url
        - centralized_permissions
        - glue_server_max_request_size
        - persistent_endpoints_ssh
        - persistent_endpoints_ssl_certificates
        - enable_disk_health_monitoring
        - enable_paused_environments
        - enable_unified_configuration
        - enable_explicit_empty_routes
        - enable_routes_tracing
        - image_deployment_validation
        - support_generic_images
        - enable_github_app_token_exchange
        - continuous_profiling
        - disable_agent_error_reporter
        - requires_domain_ownership
        - enable_guaranteed_resources
        - git_server
        - activity_logs_max_size
        - allow_manual_deployments
        - allow_rolling_deployments
        - maintenance_window
        - allow_activity_reschedule
        - allow_burst
        - router_resources
        - allow_scaling_to_zero
        - save_applications_vendors
        - locations_script_default
        - support_oci_images
      additionalProperties: false
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````